import { LitElement } from 'lit';
import { EditorView } from '@codemirror/view';
import { type EditorSelection, Transaction, type Extension, type Text } from '@codemirror/state';
export declare class CodeMirrorEditor extends LitElement {
    #private;
    static styles: import("lit").CSSResult;
    editorView?: EditorView;
    get value(): string | undefined;
    set value(v: string | undefined);
    constructor();
    render(): import("lit-html").TemplateResult<1>;
    addExtensions(extensions: Array<Extension>): void;
    removeExtensions(extensions: Array<Extension>): void;
    protected firstUpdated(): Promise<void>;
}
export declare class TransactionEvent extends Event {
    static readonly eventName = "codemirror-transaction";
    readonly transaction: Transaction;
    target: CodeMirrorEditor;
    constructor(transaction: Transaction);
}
export declare class DocumentChangeEvent extends Event {
    static readonly eventName = "codemirror-document-change";
    readonly transaction: Transaction;
    changes: Array<Change>;
    target: CodeMirrorEditor;
    constructor(transaction: Transaction, changes: Array<Change>);
}
export type Change = {
    fromA: number;
    toA: number;
    fromB: number;
    toB: number;
    inserted: Text;
};
export declare class SelectionChangeEvent extends Event {
    static readonly eventName = "codemirror-selection-change";
    readonly transaction: Transaction;
    readonly selection: EditorSelection;
    target: CodeMirrorEditor;
    constructor(transaction: Transaction, selection: EditorSelection);
}
//# sourceMappingURL=cm-editor.d.ts.map