var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import {} from 'lit';
import { customElement, property } from 'lit/decorators.js';
import { CodeMirrorExtensionElement } from './cm-extention-element.js';
import { html } from '@codemirror/lang-html';
let CodeMirrorLangJavascript = class CodeMirrorLangJavascript extends CodeMirrorExtensionElement {
    constructor() {
        super(...arguments);
        /**
         * By default, the syntax tree will highlight mismatched closing
         * tags. Set this to `true` to turn that off (for example when you
         * expect to only be parsing a fragment of HTML text, not a full
         * document).
         */
        this.noMatchClosingTags = false;
        this.selfClosingTags = false;
        /**
         * Determines whether [`autoCloseTags`](https://codemirror.net/6/docs/ref/#lang-html.autoCloseTags)
         * is included in the support extensions. Defaults to false.
         */
        this.noAutoCloseTags = false;
    }
    update(changedProperties) {
        if (changedProperties.size > 0) {
            this.setExtensions([
                html({
                    matchClosingTags: !this.noMatchClosingTags,
                    selfClosingTags: this.selfClosingTags,
                    autoCloseTags: !this.noAutoCloseTags,
                    extraTags: this.extraTags,
                    extraGlobalAttributes: this.extraGlobalAttributes,
                    nestedLanguages: this.nestedLanguages,
                    nestedAttributes: this.nestedAttributes,
                }),
            ]);
        }
        super.update(changedProperties);
    }
};
__decorate([
    property({ type: Boolean })
], CodeMirrorLangJavascript.prototype, "noMatchClosingTags", void 0);
__decorate([
    property({ type: Boolean })
], CodeMirrorLangJavascript.prototype, "selfClosingTags", void 0);
__decorate([
    property({ type: Boolean })
], CodeMirrorLangJavascript.prototype, "noAutoCloseTags", void 0);
__decorate([
    property({ type: Object, attribute: 'extra-tags' })
], CodeMirrorLangJavascript.prototype, "extraTags", void 0);
__decorate([
    property({ type: Object, attribute: 'extra-global-attributes' })
], CodeMirrorLangJavascript.prototype, "extraGlobalAttributes", void 0);
__decorate([
    property({ attribute: false })
], CodeMirrorLangJavascript.prototype, "nestedLanguages", void 0);
__decorate([
    property({ attribute: false })
], CodeMirrorLangJavascript.prototype, "nestedAttributes", void 0);
CodeMirrorLangJavascript = __decorate([
    customElement('cm-lang-html')
], CodeMirrorLangJavascript);
export { CodeMirrorLangJavascript };
//# sourceMappingURL=cm-lang-html.js.map